/**
 * <copyright>
 * </copyright>
 *
 */
package org.openxma.dsl.ddl.ddlDsl.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.openxma.dsl.ddl.ddlDsl.AddTableConstraint;
import org.openxma.dsl.ddl.ddlDsl.Alter;
import org.openxma.dsl.ddl.ddlDsl.AlterTableAction;
import org.openxma.dsl.ddl.ddlDsl.Column;
import org.openxma.dsl.ddl.ddlDsl.ColumnComment;
import org.openxma.dsl.ddl.ddlDsl.Comment;
import org.openxma.dsl.ddl.ddlDsl.Constraint;
import org.openxma.dsl.ddl.ddlDsl.Create;
import org.openxma.dsl.ddl.ddlDsl.CreateIndex;
import org.openxma.dsl.ddl.ddlDsl.CreateTable;
import org.openxma.dsl.ddl.ddlDsl.Ddl;
import org.openxma.dsl.ddl.ddlDsl.DdlDslPackage;
import org.openxma.dsl.ddl.ddlDsl.DdlStatement;
import org.openxma.dsl.ddl.ddlDsl.Drop;
import org.openxma.dsl.ddl.ddlDsl.DropTableConstraint;
import org.openxma.dsl.ddl.ddlDsl.ForeignKeyConstraint;
import org.openxma.dsl.ddl.ddlDsl.LargeObjectType;
import org.openxma.dsl.ddl.ddlDsl.LongRaw;
import org.openxma.dsl.ddl.ddlDsl.NullableConstraint;
import org.openxma.dsl.ddl.ddlDsl.PrimaryKeyConstraint;
import org.openxma.dsl.ddl.ddlDsl.Raw;
import org.openxma.dsl.ddl.ddlDsl.ReferenceClause;
import org.openxma.dsl.ddl.ddlDsl.RowIdType;
import org.openxma.dsl.ddl.ddlDsl.SqlBoolean;
import org.openxma.dsl.ddl.ddlDsl.SqlCharacter;
import org.openxma.dsl.ddl.ddlDsl.SqlDataType;
import org.openxma.dsl.ddl.ddlDsl.SqlDate;
import org.openxma.dsl.ddl.ddlDsl.SqlDateTime;
import org.openxma.dsl.ddl.ddlDsl.SqlInterval;
import org.openxma.dsl.ddl.ddlDsl.SqlNumber;
import org.openxma.dsl.ddl.ddlDsl.SqlTimeStamp;
import org.openxma.dsl.ddl.ddlDsl.TableComment;
import org.openxma.dsl.ddl.ddlDsl.TableProperty;
import org.openxma.dsl.ddl.ddlDsl.UniqueKeyConstraint;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.openxma.dsl.ddl.ddlDsl.DdlDslPackage
 * @generated
 */
public class DdlDslSwitch<T>
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static DdlDslPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DdlDslSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = DdlDslPackage.eINSTANCE;
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  public T doSwitch(EObject theEObject)
  {
    return doSwitch(theEObject.eClass(), theEObject);
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected T doSwitch(EClass theEClass, EObject theEObject)
  {
    if (theEClass.eContainer() == modelPackage)
    {
      return doSwitch(theEClass.getClassifierID(), theEObject);
    }
    else
    {
      List<EClass> eSuperTypes = theEClass.getESuperTypes();
      return
        eSuperTypes.isEmpty() ?
          defaultCase(theEObject) :
          doSwitch(eSuperTypes.get(0), theEObject);
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected T doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case DdlDslPackage.DDL:
      {
        Ddl ddl = (Ddl)theEObject;
        T result = caseDdl(ddl);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.DDL_STATEMENT:
      {
        DdlStatement ddlStatement = (DdlStatement)theEObject;
        T result = caseDdlStatement(ddlStatement);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.ALTER:
      {
        Alter alter = (Alter)theEObject;
        T result = caseAlter(alter);
        if (result == null) result = caseDdlStatement(alter);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.ALTER_TABLE_ACTION:
      {
        AlterTableAction alterTableAction = (AlterTableAction)theEObject;
        T result = caseAlterTableAction(alterTableAction);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.DROP_TABLE_CONSTRAINT:
      {
        DropTableConstraint dropTableConstraint = (DropTableConstraint)theEObject;
        T result = caseDropTableConstraint(dropTableConstraint);
        if (result == null) result = caseAlterTableAction(dropTableConstraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.COMMENT:
      {
        Comment comment = (Comment)theEObject;
        T result = caseComment(comment);
        if (result == null) result = caseDdlStatement(comment);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.TABLE_COMMENT:
      {
        TableComment tableComment = (TableComment)theEObject;
        T result = caseTableComment(tableComment);
        if (result == null) result = caseComment(tableComment);
        if (result == null) result = caseDdlStatement(tableComment);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.COLUMN_COMMENT:
      {
        ColumnComment columnComment = (ColumnComment)theEObject;
        T result = caseColumnComment(columnComment);
        if (result == null) result = caseComment(columnComment);
        if (result == null) result = caseDdlStatement(columnComment);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.ADD_TABLE_CONSTRAINT:
      {
        AddTableConstraint addTableConstraint = (AddTableConstraint)theEObject;
        T result = caseAddTableConstraint(addTableConstraint);
        if (result == null) result = caseAlterTableAction(addTableConstraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.CREATE:
      {
        Create create = (Create)theEObject;
        T result = caseCreate(create);
        if (result == null) result = caseDdlStatement(create);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.CREATE_TABLE:
      {
        CreateTable createTable = (CreateTable)theEObject;
        T result = caseCreateTable(createTable);
        if (result == null) result = caseCreate(createTable);
        if (result == null) result = caseDdlStatement(createTable);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.CREATE_INDEX:
      {
        CreateIndex createIndex = (CreateIndex)theEObject;
        T result = caseCreateIndex(createIndex);
        if (result == null) result = caseCreate(createIndex);
        if (result == null) result = caseDdlStatement(createIndex);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.TABLE_PROPERTY:
      {
        TableProperty tableProperty = (TableProperty)theEObject;
        T result = caseTableProperty(tableProperty);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.COLUMN:
      {
        Column column = (Column)theEObject;
        T result = caseColumn(column);
        if (result == null) result = caseTableProperty(column);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.DROP:
      {
        Drop drop = (Drop)theEObject;
        T result = caseDrop(drop);
        if (result == null) result = caseDdlStatement(drop);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.CONSTRAINT:
      {
        Constraint constraint = (Constraint)theEObject;
        T result = caseConstraint(constraint);
        if (result == null) result = caseTableProperty(constraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.NULLABLE_CONSTRAINT:
      {
        NullableConstraint nullableConstraint = (NullableConstraint)theEObject;
        T result = caseNullableConstraint(nullableConstraint);
        if (result == null) result = caseConstraint(nullableConstraint);
        if (result == null) result = caseTableProperty(nullableConstraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.UNIQUE_KEY_CONSTRAINT:
      {
        UniqueKeyConstraint uniqueKeyConstraint = (UniqueKeyConstraint)theEObject;
        T result = caseUniqueKeyConstraint(uniqueKeyConstraint);
        if (result == null) result = caseConstraint(uniqueKeyConstraint);
        if (result == null) result = caseTableProperty(uniqueKeyConstraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.PRIMARY_KEY_CONSTRAINT:
      {
        PrimaryKeyConstraint primaryKeyConstraint = (PrimaryKeyConstraint)theEObject;
        T result = casePrimaryKeyConstraint(primaryKeyConstraint);
        if (result == null) result = caseConstraint(primaryKeyConstraint);
        if (result == null) result = caseTableProperty(primaryKeyConstraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.FOREIGN_KEY_CONSTRAINT:
      {
        ForeignKeyConstraint foreignKeyConstraint = (ForeignKeyConstraint)theEObject;
        T result = caseForeignKeyConstraint(foreignKeyConstraint);
        if (result == null) result = caseConstraint(foreignKeyConstraint);
        if (result == null) result = caseTableProperty(foreignKeyConstraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.REFERENCE_CLAUSE:
      {
        ReferenceClause referenceClause = (ReferenceClause)theEObject;
        T result = caseReferenceClause(referenceClause);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_DATA_TYPE:
      {
        SqlDataType sqlDataType = (SqlDataType)theEObject;
        T result = caseSqlDataType(sqlDataType);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_BOOLEAN:
      {
        SqlBoolean sqlBoolean = (SqlBoolean)theEObject;
        T result = caseSqlBoolean(sqlBoolean);
        if (result == null) result = caseSqlDataType(sqlBoolean);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_CHARACTER:
      {
        SqlCharacter sqlCharacter = (SqlCharacter)theEObject;
        T result = caseSqlCharacter(sqlCharacter);
        if (result == null) result = caseSqlDataType(sqlCharacter);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_NUMBER:
      {
        SqlNumber sqlNumber = (SqlNumber)theEObject;
        T result = caseSqlNumber(sqlNumber);
        if (result == null) result = caseSqlDataType(sqlNumber);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.LONG_RAW:
      {
        LongRaw longRaw = (LongRaw)theEObject;
        T result = caseLongRaw(longRaw);
        if (result == null) result = caseSqlDataType(longRaw);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.LONG:
      {
        org.openxma.dsl.ddl.ddlDsl.Long long_ = (org.openxma.dsl.ddl.ddlDsl.Long)theEObject;
        T result = caseLong(long_);
        if (result == null) result = caseLongRaw(long_);
        if (result == null) result = caseSqlDataType(long_);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.RAW:
      {
        Raw raw = (Raw)theEObject;
        T result = caseRaw(raw);
        if (result == null) result = caseLongRaw(raw);
        if (result == null) result = caseSqlDataType(raw);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_DATE_TIME:
      {
        SqlDateTime sqlDateTime = (SqlDateTime)theEObject;
        T result = caseSqlDateTime(sqlDateTime);
        if (result == null) result = caseSqlDataType(sqlDateTime);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_DATE:
      {
        SqlDate sqlDate = (SqlDate)theEObject;
        T result = caseSqlDate(sqlDate);
        if (result == null) result = caseSqlDateTime(sqlDate);
        if (result == null) result = caseSqlDataType(sqlDate);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_TIME_STAMP:
      {
        SqlTimeStamp sqlTimeStamp = (SqlTimeStamp)theEObject;
        T result = caseSqlTimeStamp(sqlTimeStamp);
        if (result == null) result = caseSqlDateTime(sqlTimeStamp);
        if (result == null) result = caseSqlDataType(sqlTimeStamp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.SQL_INTERVAL:
      {
        SqlInterval sqlInterval = (SqlInterval)theEObject;
        T result = caseSqlInterval(sqlInterval);
        if (result == null) result = caseSqlDateTime(sqlInterval);
        if (result == null) result = caseSqlDataType(sqlInterval);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.LARGE_OBJECT_TYPE:
      {
        LargeObjectType largeObjectType = (LargeObjectType)theEObject;
        T result = caseLargeObjectType(largeObjectType);
        if (result == null) result = caseSqlDataType(largeObjectType);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case DdlDslPackage.ROW_ID_TYPE:
      {
        RowIdType rowIdType = (RowIdType)theEObject;
        T result = caseRowIdType(rowIdType);
        if (result == null) result = caseSqlDataType(rowIdType);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Ddl</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Ddl</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseDdl(Ddl object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Ddl Statement</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Ddl Statement</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseDdlStatement(DdlStatement object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Alter</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Alter</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseAlter(Alter object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Alter Table Action</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Alter Table Action</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseAlterTableAction(AlterTableAction object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Drop Table Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Drop Table Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseDropTableConstraint(DropTableConstraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Comment</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Comment</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseComment(Comment object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Table Comment</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Table Comment</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseTableComment(TableComment object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Column Comment</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Column Comment</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseColumnComment(ColumnComment object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Add Table Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Add Table Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseAddTableConstraint(AddTableConstraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Create</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Create</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCreate(Create object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Create Table</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Create Table</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCreateTable(CreateTable object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Create Index</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Create Index</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCreateIndex(CreateIndex object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Table Property</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Table Property</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseTableProperty(TableProperty object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Column</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Column</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseColumn(Column object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Drop</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Drop</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseDrop(Drop object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseConstraint(Constraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Nullable Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Nullable Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseNullableConstraint(NullableConstraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Unique Key Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Unique Key Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseUniqueKeyConstraint(UniqueKeyConstraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Primary Key Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Primary Key Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T casePrimaryKeyConstraint(PrimaryKeyConstraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Foreign Key Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Foreign Key Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseForeignKeyConstraint(ForeignKeyConstraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Reference Clause</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Reference Clause</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseReferenceClause(ReferenceClause object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Data Type</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Data Type</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlDataType(SqlDataType object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Boolean</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Boolean</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlBoolean(SqlBoolean object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Character</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Character</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlCharacter(SqlCharacter object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Number</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Number</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlNumber(SqlNumber object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Long Raw</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Long Raw</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseLongRaw(LongRaw object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Long</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Long</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseLong(org.openxma.dsl.ddl.ddlDsl.Long object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Raw</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Raw</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseRaw(Raw object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Date Time</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Date Time</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlDateTime(SqlDateTime object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Date</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Date</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlDate(SqlDate object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Time Stamp</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Time Stamp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlTimeStamp(SqlTimeStamp object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Sql Interval</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Sql Interval</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseSqlInterval(SqlInterval object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Large Object Type</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Large Object Type</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseLargeObjectType(LargeObjectType object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Row Id Type</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Row Id Type</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseRowIdType(RowIdType object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  public T defaultCase(EObject object)
  {
    return null;
  }

} //DdlDslSwitch
